<html>
<head>
<title>OgreShaderCGProgramWriter.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderCGProgramWriter.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderCGProgramWriter_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ShaderProgramWriterCG_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ShaderProgramWriterCG_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderProgramWriterManager_8h.html">OgreShaderProgramWriterManager.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 <span class="keyword">namespace </span>RTShader {
<a name="l00035"></a>00035 
<a name="l00046"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html">00046</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html" title="CG target language writer implementation.">CGProgramWriter</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">// Interface.</span>
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00055"></a>00055     <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html" title="CG target language writer implementation.">CGProgramWriter</a> ();
<a name="l00056"></a>00056 
<a name="l00058"></a>00058     <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html" title="CG target language writer implementation.">CGProgramWriter</a> ();
<a name="l00059"></a>00059 
<a name="l00063"></a>00063     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeSourceCode         (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aebc63f8a4ec1ef6d0985621902140089">00068</a>     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;  <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#aebc63f8a4ec1ef6d0985621902140089">getTargetLanguage</a>            ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> TargetLanguage; }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae30fa976742fc69297a072d716987820">00070</a>     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#ae30fa976742fc69297a072d716987820">TargetLanguage</a>;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="comment">// Protected methods.</span>
<a name="l00073"></a>00073 <span class="keyword">protected</span>:
<a name="l00074"></a>00074 
<a name="l00076"></a>00076     <span class="keywordtype">void</span>        initializeStringMaps        ();
<a name="l00077"></a>00077 
<a name="l00079"></a>00079     <span class="keywordtype">void</span>        writeProgramDependencies    (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00080"></a>00080     
<a name="l00082"></a>00082     <span class="keywordtype">void</span>        writeUniformParameter       (std::ostream&amp; os, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">UniformParameterPtr</a> parameter);
<a name="l00083"></a>00083 
<a name="l00085"></a>00085     <span class="keywordtype">void</span>        writeFunctionParameter      (std::ostream&amp; os, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00086"></a>00086 
<a name="l00088"></a>00088     <span class="keywordtype">void</span>        writeLocalParameter         (std::ostream&amp; os, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00089"></a>00089 
<a name="l00091"></a>00091     <span class="keywordtype">void</span>        writeFunctionDeclaration    (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> &amp; colorParameter);
<a name="l00092"></a>00092 
<a name="l00094"></a>00094     <span class="keywordtype">void</span>        writeAtomInstance           (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a>* atom);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="keyword">protected</span>:
<a name="l00098"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">00098</a>     <span class="keyword">typedef</span>     <a class="code" href="structOgre_1_1map.html">map&lt;GpuConstantType, const char*&gt;::type</a>     <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">GpuConstTypeToStringMap</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">00099</a>     <span class="keyword">typedef</span>     <a class="code" href="structOgre_1_1map.html">map&lt;Parameter::Semantic, const char*&gt;::type</a> <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">ParamSemanticToStringMap</a>;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="comment">// Attributes.</span>
<a name="l00102"></a>00102 <span class="keyword">protected</span>:
<a name="l00103"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a5a58fdcb44c6559c31e2007d942da9b9">00103</a>     <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a15bcc4a4f766470b97509947eebc9a4b">GpuConstTypeToStringMap</a>     <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a5a58fdcb44c6559c31e2007d942da9b9">mGpuConstTypeMap</a>;       <span class="comment">// Map between GPU constant type to string value.</span>
<a name="l00104"></a><a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a22775b23abba17b8797238e1a227703e">00104</a>     <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a10765b92adccc1bad92a3ea020135a3f">ParamSemanticToStringMap</a>    <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html#a22775b23abba17b8797238e1a227703e">mParamSemanticMap</a>;      <span class="comment">// Map between parameter semantic to string value.</span>
<a name="l00105"></a>00105 };
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html">00110</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html" title="CG program writer factory implementation.">ShaderProgramWriterCGFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriterFactory.html" title="Interface definition for factories of ShaderProgramWriter.">ProgramWriterFactory</a>
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112 <span class="keyword">public</span>:
<a name="l00113"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#a20a79eccac89cb46237c25868d3e12cf">00113</a>     <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html" title="CG program writer factory implementation.">ShaderProgramWriterCGFactory</a>()
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115         mLanguage = <span class="stringliteral">&quot;cg&quot;</span>;
<a name="l00116"></a>00116     }
<a name="l00117"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#a78cbec30bae4413d5c3a491ba4404ddc">00117</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#a78cbec30bae4413d5c3a491ba4404ddc">~ShaderProgramWriterCGFactory</a>() {}
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#a947090bc45eaf52e2b2f8b7a054596e5">00122</a>     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTargetLanguage(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword">    </span>{
<a name="l00124"></a>00124         <span class="keywordflow">return</span> mLanguage;
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#afc10125c66c4708bc336fb163812de58">00130</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>* create(<span class="keywordtype">void</span>)
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132         <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1RTShader_1_1CGProgramWriter.html" title="CG target language writer implementation.">CGProgramWriter</a>();
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="keyword">private</span>:
<a name="l00136"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#ad65a94dad085380b869cb7a577b334c2">00136</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterCGFactory.html#ad65a94dad085380b869cb7a577b334c2">mLanguage</a>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
